package io.gmss.fiscad.implementations.infocad.parametre;

import io.gmss.fiscad.entities.infocad.parametre.TypeContestation;
import io.gmss.fiscad.exceptions.BadRequestException;
import io.gmss.fiscad.exceptions.NotFoundException;
import io.gmss.fiscad.interfaces.infocad.parametre.TypeContestationService;
import io.gmss.fiscad.repositories.infocad.parametre.TypeContestationRepository;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Optional;

@Service
public class TypeContestationServiceImpl implements TypeContestationService {

    private final TypeContestationRepository typeContestationRepository;

    public TypeContestationServiceImpl(TypeContestationRepository typeContestationRepository) {
        this.typeContestationRepository = typeContestationRepository;
    }

    @Override
    public TypeContestation createTypeContestation(TypeContestation typeContestation) throws BadRequestException {
        if (typeContestation.getId() != null) {
            throw new BadRequestException("Impossible de créer un nouveau type de contestation ayant un id non null.");
        }
        return typeContestationRepository.save(typeContestation);
    }

    @Override
    public TypeContestation updateTypeContestation(Long id, TypeContestation typeContestation) throws NotFoundException {
        if (typeContestation.getId() == null) {
            throw new BadRequestException("Impossible de mettre à jour un nouveau type de contestation ayant un id null.");
        }
        if (!typeContestationRepository.existsById(typeContestation.getId())) {
            throw new NotFoundException("Impossible de trouver le type de contestation spécifié dans notre base de données.");
        }
        return typeContestationRepository.save(typeContestation);
    }

    @Override
    public void deleteTypeContestation(Long id) throws NotFoundException {
        Optional<TypeContestation> typeContestationOptional = typeContestationRepository.findById(id);
        if (typeContestationOptional.isPresent()) {
            typeContestationRepository.deleteById(typeContestationOptional.get().getId());
        } else {
            throw new NotFoundException("Impossible de trouver le type de contestation spécifié dans notre base de données.");
        }
    }

    @Override
    public Page<TypeContestation> getTypeContestationList(Pageable pageable) {
        return typeContestationRepository.findAll(pageable);
    }

    @Override
    public List<TypeContestation> getTypeContestationList() {
        return typeContestationRepository.findAll();
    }

    @Override
    public Optional<TypeContestation> getTypeContestationById(Long id) {
        if (typeContestationRepository.existsById(id)) {
            return typeContestationRepository.findById(id);
        } else {
            throw new NotFoundException("Impossible de trouver le type de contestation spécifié dans la base de données.");
        }

    }
}
